#version 130

//@see http://flammpfeil.appspot.com/trinketbox/
//put FireParticleSystemEx.png in same folder/directory

#define particleShape 0.0937

uniform sampler2D tex;
varying float     alpha;

void main (void){
	if(alpha <= 0.0) discard;

	vec2  point      = gl_PointCoord - 0.5;
	float radius     = length(point);
	if(radius>0.5) discard;
	// Fade the particle to a circular shape
	float fade = pow(radius, particleShape);
	point.x = radius + 0.5;
	point.y = 0.0;

	gl_FragColor    = texture(tex,          point);

	gl_FragColor.a *= alpha;
	gl_FragColor.a *= fade;

	if(gl_FragColor.a <= 0.0) discard;
}
