//@see http://www.nicovideo.jp/watch/sm22353926

#define PI               3.141592
#define AnimeSpeed       0.8
#define HoleTime         0.7
#define FadeTime         0.2
#define HoleSize         0.9
#define HoleSlideMin     0.1
#define HoleSlideMax     0.3
#define ParticleSizeMin  1.0
#define ParticleSizeMax  2.0

varying vec2  HoleCenter;
varying float HoleRadius;
varying float alpha;

uniform float time;

void main(void){
	float iRatio = fract(gl_Vertex.z);
	float iTimeRound;
	float iTime  = modf(iRatio + time * AnimeSpeed , iTimeRound);
	float random = fract(gl_Vertex.z*2.0+gl_Vertex.y*3.0);
	float particleSize = gl_Point.size;
	particleSize *= mix(ParticleSizeMin, ParticleSizeMax, random) * pow(iTime, 0.5);

//	float holeTheta = gl_Vertex.x*PI*2.0;
	HoleCenter.st = vec2( cos(gl_Vertex.x), sin(gl_Vertex.x) )
					*mix( HoleSlideMin, HoleSlideMax, fract(gl_Vertex.y) );
	HoleRadius    = pow( clamp((iTime-(1.0-HoleTime))/HoleTime, 0.0, 1.0), 0.5 ) * HoleSize;
	alpha   = clamp(1.0-(iTime-(1.0-FadeTime))/FadeTime, 0.0, 1.0);

//	gl_TexCoord[0] = gl_TextureMatrix[0] * gl_MultiTexCoord0;
	gl_Position    = ftransform();
	gl_PointSize   = particleSize / gl_Position.w;
}
